OUTPUT_FORMAT("coff-sh")
OUTPUT_ARCH(sh)
MEMORY
{
  rom    : o = 0x00400400, l = 0x0007ec00
  ram    : o = 0x00480000, l = 0x0007f000
  stack  : o = 0x004feff0, l = 0x00000010
}
SECTIONS
{
  .text :
  {
     _stext = . ;
    *(.text)
    *(.strings)
     _etext = . ;
  }  > rom
  .data : AT ( ADDR (.text) + SIZEOF (.text) )
  {
     _sdata = . ;
    *(.data)
     _edata = . ;
  }  > ram
  .bss :
  {
     _bss_start = . ;
    *(.bss)
    *(COMMON)
     _end = . ;
  }  > ram
  .stack :
  {
     _stack_top = . ;
    *(.stack)
  } > stack
}
