#include	"sh7060s.h"
#include	"gmachine.h"
#include	"userlog.h"
#define		UserLogAdd	0x080ff000	/* ޯpRAM̈̐擪w肷	*/

void	boot(void);
void	__main(void);
int		main(void);

void	sectionInit(void);
void	cmt0_init(void);
void	int_cmi0(void);
void	tpu0_init(void);
void	int_tpu0(void);

long	UserLogTimer = 0;

/************************************/
/*	__main(_~[)					*/
/************************************/
void __main(void)
{
}

/************************************/
/*	CPU						*/
/************************************/
void boot(void)
{
	/* hn|[gݒ */
	PFC.PACRH1.WORD = 0x0000;		/*	PA25	ėpo		*/
									/*	PA24	ėpo		*/
	PFC.PACRH2.WORD = 0x1115;		/*	PA23	ėpo		*/
									/*	PA22	CS2				*/
									/*	PA21	ėpo		*/
									/*	PA20	CS0				*/
									/*	PA19	ėpo		*/
									/*	PA18	RD				*/
									/*	PA17	WR				*/
									/*	PA16	WRHH or HHBS	*/
	PFC.PACRL1.WORD = 0x5400;		/*	PA15	WRHL or HLBS	*/
									/*	PA14	WRLH or LHBS	*/
									/*	PA13	WRLL or LLBS	*/
									/*	PA12	ėpo		*/
									/*	PA9		ėpo		*/
									/*	PA8		ėpo		*/
	PFC.PACRL2.WORD = 0x0000;		/*	PA1		ėpo		*/
									/*	PA0		ėpo		*/


	PFC.PBCRH2.WORD = 0x0000;		/*	PB23	ėpo		*/
									/*	PB22	ėpo		*/
									/*	PB21	ėpo		*/
									/*	PB20	ėpo		*/
									/*	PB19	ėpo		*/
									/*	PB18	ėpo		*/
									/*	PB17	ėpo		*/
									/*	PB16	ėpo		*/
	PFC.PBCRL1.WORD = 0x0000;		/*	PB13	ėpo		*/
	PFC.PBCRL2.WORD = 0x0000;		/*	PB7		ėpo		*/
									/*	PB6		ėpo		*/


	PFC.PCCRH1.WORD = 0x0000;		/*	PC25	ėpo		*/
									/*	PC24	ėpo		*/
	PFC.PCCRH2.WORD = 0x0055;		/*	PC23	ėpo		*/
									/*	PC22	ėpo		*/
									/*	PC21	ėpo		*/
									/*	PC20	ėpo		*/
									/*	PC19	A19				*/
									/*	PC18	A18				*/
									/*	PC17	A17				*/
									/*	PC16	A16				*/
	PFC.PCCRL1.WORD = 0x5555;		/*	PC15	A15				*/
									/*	PC14	A14				*/
									/*	PC13	A13				*/
									/*	PC12	A12				*/
									/*	PC11	A11				*/
									/*	PC10	A10				*/
									/*	PC9		A9				*/
									/*	PC8		A8				*/
	PFC.PCCRL2.WORD = 0x5555;		/*	PC7		A7				*/
									/*	PC6		A6				*/
									/*	PC5		A5				*/
									/*	PC4		A4				*/
									/*	PC3		A3				*/
									/*	PC2		A2				*/
									/*	PC1		A1				*/
									/*	PC0		A0				*/


	PFC.PDCRH1.WORD = 0x5555;		/*	PD31	D31				*/
									/*	PD30	D30				*/
									/*	PD29	D29				*/
									/*	PD28	D28				*/
									/*	PD27	D27				*/
									/*	PD26	D26				*/
									/*	PD25	D25				*/
									/*	PD24	D24				*/
	PFC.PDCRH2.WORD = 0x5555;		/*	PD23	D23				*/
									/*	PD22	D22				*/
									/*	PD21	D21				*/
									/*	PD20	D20				*/
									/*	PD19	D19				*/
									/*	PD18	D18				*/
									/*	PD17	D17				*/
									/*	PD16	D16				*/
	PFC.PDCRL1.WORD = 0x5555;		/*	PD15	D15				*/
									/*	PD14	D14				*/
									/*	PD13	D13				*/
									/*	PD12	D12				*/
									/*	PD11	D11				*/
									/*	PD10	D10				*/
									/*	PD9		D9				*/
									/*	PD8		D8				*/
	PFC.PDCRL2.WORD = 0x5555;		/*	PD7		D7				*/
									/*	PD6		D6				*/
									/*	PD5		D5				*/
									/*	PD4		D4				*/
									/*	PD3		D3				*/
									/*	PD2		D2				*/
									/*	PD1		D1				*/
									/*	PD0		D0				*/


	PFC.PECRH2.WORD = 0x0000;		/*	PE23	ėpo		*/
									/*	PE22	ėpo		*/
									/*	PE21	ėpo		*/
									/*	PE20	ėpo		*/
									/*	PE19	ėpo		*/
									/*	PE18	ėpo		*/
									/*	PE17	ėpo		*/
									/*	PE16	ėpo		*/
	PFC.PECRL.WORD = 0x0000;		/*	PE15	ėpo		*/
									/*	PE14	ėpo		*/
									/*	PE13	ėpo		*/
									/*	PE12	ėpo		*/

	PFC.PFCRL2.WORD = 0x0000;		/*	PF7		ėpo		*/
									/*	PF6		ėpo		*/
									/*	PF5		ėpo		*/
									/*	PF3		ėpo		*/
									/*	PF2		ėpo		*/
									/*	PF1		ėpo		*/


	PFC.PGCRH1.WORD = 0x5000;		/*	PG31	RxD2			*/
									/*	PG30	TxD2			*/
									/*	PG29	ėpo		*/


	PFC.PHCR.WORD = 0x0000;			/*	PH1		ėpo		*/
									/*	PH0		ėpo		*/


	PFC.FCR.BYTE = 0x00;			/*	SCIo	CMOSo		*/
									/*	IRQOUT	ݗvto	*/



	PFC.PAIORH.WORD = 0x03a8;		/*	PA25	o			*/
									/*	PA24	o			*/
									/*	PA23	o			*/
									/*	PA22					*/
									/*	PA21	o			*/
									/*	PA20					*/
									/*	PA19	o			*/
									/*	PA18					*/
									/*	PA17					*/
									/*	PA16					*/
	PFC.PAIORL.WORD = 0x1303;		/*	PA15					*/
									/*	PA14					*/
									/*	PA13					*/
									/*	PA12	o			*/
									/*	PA9		o			*/
									/*	PA8		o			*/
									/*	PA1		o			*/
									/*	PA0		o			*/


	PFC.PBIORH.WORD = 0x00ff;		/*	PB23	o			*/
									/*	PB22	o			*/
									/*	PB21	o			*/
									/*	PB20	o			*/
									/*	PB19	o			*/
									/*	PB18	o			*/
									/*	PB17	o			*/
									/*	PB16	o			*/
	PFC.PBIORL.WORD = 0x20c0;		/*	PB13	o			*/
									/*	PB7		o			*/
									/*	PB6		o			*/


	PFC.PCIORH.WORD = 0x03f0;		/*	PC25	o			*/
									/*	PC24	o			*/
									/*	PC23	o			*/
									/*	PC22	o			*/
									/*	PC21	o			*/
									/*	PC20	o			*/
									/*	PC19					*/
									/*	PC18					*/
									/*	PC17					*/
									/*	PC16					*/
	PFC.PCIORL.WORD = 0x0000;		/*	PC15`PC0				*/


	PFC.PDIORH.WORD = 0x0000;		/*	PD31`PD16				*/
	PFC.PDIORL.WORD = 0x0000;		/*	PD15`PD0				*/


	PFC.PEIORH.WORD = 0x00ff;		/*	PE23	o			*/
									/*	PE22	o			*/
									/*	PE21	o			*/
									/*	PE20	o			*/
									/*	PE19	o			*/
									/*	PE18	o			*/
									/*	PE17	o			*/
									/*	PE16	o			*/
	PFC.PEIORL.WORD = 0xf000;		/*	PE15	o			*/
									/*	PE14	o			*/
									/*	PE13	o			*/
									/*	PE12	o			*/


	PFC.PFIORL.WORD = 0x00ee;		/*	PF7		o			*/
									/*	PF6		o			*/
									/*	PF5		o			*/
									/*	PF3		o			*/
									/*	PF2		o			*/
									/*	PF1		o			*/


	PFC.PGIOR.WORD = 0x2000;		/*	PG31	RxD2			*/
									/*	PG30	TxD2			*/
									/*	PG29	o			*/


	PFC.PHIOR.WORD = 0x0003;		/*	PH1		o			*/
									/*	PH0		o			*/

	sectionInit();						/*					*/

	main();
}

/************************************/
/*	MAIN֐						*/
/************************************/
int
main()
{
	char	data;
	char	buf[10] = "Count =  ";
	short	UserLogCount = 0;

	cmt0_init();						/*	CMT0					*/
	tpu0_init();						/*	TPU0					*/

	UserLogInit(UserLogAdd);			/* հް۸޸ڽݒ			*/

	set_imask(0);						/*	荞݃}XN			*/

	for(;;) {
		if ( 100 <= UserLogTimer ) {
			UserLogTimer = 0;
			buf[8] = UserLogCount | 0x30;
			UserLogPut(&buf[0]);		/* հް۸ޕ\			*/
			UserLogCount++;
			if (UserLogCount >= 10 ){
				UserLogCount = 0;
			}
		}
	}
	return 0;
}

/************************************/
/*	ZNV				*/
/************************************/
extern char etext, sdata, edata, bss_start, end;
void
sectionInit()
{
	char	*src;
	char	*dst;

	/*	f[^̈	*/
	src	= &etext;
	dst	= &sdata;
	while (dst < &edata) {
		*dst++	= *src++;
	}
	/*	f[^̈	*/
	for ( dst = &bss_start; dst < &end; dst++ ) {
		*dst = 0;
	}
}

/************************************/
/*	CMT0						*/
/************************************/
void cmt0_init(void)
{
	def_int_hdr(204,(void*)int_cmi0);	/*荞݃nh̐ݒ			*/

	INTC.IPRL.WORD	&= ~0xf000;			/*	CMT0 InterruptLevel = 7			*/
	INTC.IPRL.WORD	|= 0x7000;			/*	CMT0 InterruptLevel = 7			*/

	CMT.CMSTR.BYTE	&= ~0x01;			/*	CMCNTJEg~				*/
	CMT0.CMCSR.WORD	= 0x0040;			/*	NbNӁ^W, ݋		*/
	CMT0.CMCOR		= 37500-1;			/*	(30MHz/8)/37500 = 10msec		*/
	CMT0.CMCSR.WORD &= ~0x0080;			/*	bleNA					*/
	CMT.CMSTR.BYTE	|= 0x01;			/*	CMCNTJEgJn				*/
}

/************************************/
/*	CMT0荞					*/
/************************************/
#pragma interrupt
void int_cmi0(void)
{
	static char		flag;

	CMT0.CMCSR.WORD &= ~0x0080;			/*bleNA				*/
	/*	|[gON/OFF	*/
	if( 0 != flag ) {
		PE.DR.WORD.H |= 0x00ff;			/*	Port E	*/
		PE.DR.WORD.L |= 0xf000;
		PF.DR.WORD   |= 0x00ee;			/*	Port F	*/
		PG.DR.WORD   |= 0x2000;			/*	Port G	*/
		PH.DR.BYTE   |= 0x03;			/*	Port H	*/
		flag = 0;
	} else {
		PE.DR.WORD.H &= ~0x00ff;		/*	Port E	*/
		PE.DR.WORD.L &= ~0xf000;
		PF.DR.WORD   &= ~0x00ee;		/*	Port F	*/
		PG.DR.WORD   &= ~0x2000;		/*	Port G	*/
		PH.DR.BYTE   &= ~0x03;			/*	Port H	*/
		flag = 1;
	}
	UserLogTimer++;
}

/************************************/
/*	TPU ϰƼ					*/
/************************************/
void tpu0_init(void)
{
	def_int_hdr(140,(void*)int_tpu0);	/*荞݃nh̐ݒ			*/

	INTC.IPRH.WORD		&= ~0xf000;		/*	TPU0 InterruptLevel = 7			*/
	INTC.IPRH.WORD		|= 0x7000;		/*	TPU0 InterruptLevel = 7			*/

	TPU.TSTR.BYTE		&= ~0x01;		/*JEg~						*/
	TPU0.TCR.BYTE		= 0x22;			/*sfq`̃RyA}b`			*/
										/*オGbWŃJEg		*/
										/*Ӂ^USŃJEg				*/
	TPU0.TMDR.BYTE = 0x00;				/*	TGRA,TGRB		ʏ퓮		*/
	TPU0.TIOR.WORD = 0x0000;			/*	I/Oo͋֎~						*/
	
	TPU0.TCNT = 0x0000;					/*	JE^NA					*/
	TPU0.TGRA = 9375 - 1;				/*	(30MHz/16)/9375 = 5msec		*/
	
	TPU0.TIER.BYTE = 0x01;				/*	TGFA݋					*/
	TPU0.TSR.BYTE &= 0x00;				/*	Xe[^XNA				*/
	TPU.TSTR.BYTE |= 0x01;				/*	TCNT0	JEgJn			*/
}

/********************************************/
/*	lstO荞						*/
/********************************************/
#pragma interrupt
void int_tpu0(void)
{
	static char		flag;
	static short	count = 0;

	TPU0.TSR.BYTE		&= ~0x01;		/*TGFANA						*/

	if( flag == 0 ) {
		PA.DR.WORD.H |= 0x03a8;			/*	Port A	*/
		PA.DR.WORD.L |= 0x1303;
		PB.DR.WORD.H |= 0x00ff;			/*	Port B	*/
		PB.DR.WORD.L |= 0x20c0;
		PC.DR.WORD.H |= 0x01f0;			/*	Port C	*/
		flag = 1;
	} else {
		PA.DR.WORD.H &= ~0x03a8;		/*	Port A	*/
		PA.DR.WORD.L &= ~0x1303;
		PB.DR.WORD.H &= ~0x00ff;		/*	Port B	*/
		PB.DR.WORD.L &= ~0x20c0;
		PC.DR.WORD.H &= ~0x01f0;		/*	Port C	*/
		flag = 0;
	}

	/*	LEDON/OFF	*/
	count++;
	if ( 100 <= count ) {
		count = 0;
		PC.DR.WORD.H ^= 0x0200;		/*	Port C	*/
	}
}
