#include	"sh7055.h"
#include	"gmachine.h"
#include	"userlog.h"
#define		UserLogAdd	0xFFFFD000	/* ޯpRAM̈̐擪w肷	*/

void	boot(void);
void	__main(void);
int		main(void);

void	sectionInit(void);
void	cmt0_init(void);
void	int_cmi0(void);
void	atu3_init(void);
void	int_atu3(void);

long	UserLogTimer = 0;

/************************************/
/*	__main(_~[)					*/
/************************************/
void __main(void)
{
}

/************************************/
/*	CPU						*/
/************************************/
void boot(void)
{
	sectionInit();						/*					*/

	main();
}

/************************************/
/*	MAIN֐						*/
/************************************/
int
main()
{
	char	data;
	char	buf[10] = "Count =  ";
	short	UserLogCount = 0;

	cmt0_init();						/*	CMT0					*/
	atu3_init();

	UserLogInit(UserLogAdd);			/* հް۸޸ڽݒ			*/

	set_imask(0);						/*	荞݃}XN			*/

	for(;;) {
		if ( 100 <= UserLogTimer ) {
			UserLogTimer = 0;
			buf[8] = UserLogCount | 0x30;
			UserLogPut(&buf[0]);		/* հް۸ޕ\			*/
			UserLogCount++;
			if (UserLogCount >= 10 ){
				UserLogCount = 0;
			}
		}
	}
	return 0;
}

/************************************/
/*	ZNV				*/
/************************************/
extern char etext, sdata, edata, bss_start, end;
void
sectionInit()
{
	char	*src;
	char	*dst;

	/*	f[^̈	*/
	src	= &etext;
	dst	= &sdata;
	while (dst < &edata) {
		*dst++	= *src++;
	}
	/*	f[^̈	*/
	for ( dst = &bss_start; dst < &end; dst++ ) {
		*dst = 0;
	}
}

/************************************/
/*	CMT0						*/
/************************************/
void cmt0_init(void)
{
	def_int_hdr( 188,(void*)int_cmi0);	/* 荞݃nh̐ݒ		*/

	INTC.IPRJ.WORD		&= ~0x0f00;
	INTC.IPRJ.WORD		|= 0x0700;		/*	CMT0 InterruptLevel = 7			*/

	CMT.CMSTR.WORD		&= ~0x0001;		/*	CMCNTJEg~				*/
	CMT0.CMCSR.WORD		= 0x0040;		/*	NbNӁ^W, ݋		*/
	CMT0.CMCOR			= 0x61a8-1;		/*	1/((20MHz/8)/25000) = 10msec	*/
	CMT.CMSTR.WORD		|= 0x0001;		/*	CMCNTJEgJn				*/
}

/************************************/
/*	CMT0荞					*/
/************************************/
#pragma interrupt
void int_cmi0(void)
{
	static char		flag;

	CMT0.CMCSR.WORD &= ~0x0080;			/*bleNA				*/
	/*	|[gON/OFF	*/
	if( 0 != flag ) {
		flag = 0;
	} else {
		flag = 1;
	}
	UserLogTimer++;
}

/************************************/
/*	ATU3						*/
/************************************/
void atu3_init(void)
{
	def_int_hdr( 120,(void*)int_atu3);		/* 荞݃nh̐ݒ		*/

	INTC.IPRF.WORD		&= ~0xf000;
	INTC.IPRF.WORD		|= 0x7000;			/*	ATU3 InterruptLevel = 7		*/

	ATU.TSTR1.BYTE &= ~0x10;				/* TCNT3 ~					*/
	ATU.PSCR1.BYTE = 0x00;					/* vXP[ : 1 / 1			*/
	ATU3.TCR.BYTE = 0x03;					/* オGbWA 1 / 8 */
	ATU3.TIORA.BYTE = 0x09;					/* GRA RyA TCNT NA	*/
											/* GRB,GRA Oo͋֎~			*/
	ATU3.TIORB.BYTE = 0x00;					/* GRD,GRC Oo͋֎~			*/
	ATU3.GRA = 0x30d4 - 1;					/*	1/(20MHz/8/12500) = 5msec	*/
	ATU3.TCNT = 0;
	ATU3.TIER.WORD = 0x0001;				/* IME1A 荞݋			*/

	ATU3.TSR.WORD &= ~0x001f;				/* 荞݃tONA			*/
	ATU.TSTR1.BYTE |= 0x10;					/* TCNT3 					*/
}

/************************************/
/*	ATU3荞					*/
/************************************/
#pragma interrupt
void int_atu3(void)
{
	static char		flag;

	ATU3.TSR.WORD &= ~0x001f;				/* 荞݃tONA			*/

	if( flag == 0 ) {
		flag = 1;
	} else {
		flag = 0;
	}
}
